/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.bussinessGoods.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.modules.guosen.bussiness.entity.Bussiness;
import org.springblade.modules.guosen.bussiness.service.IBussinessService;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.guosen.bussinessGoods.entity.BussinessGoods;
import org.springblade.modules.guosen.bussinessGoods.vo.BussinessGoodsVO;
import org.springblade.modules.guosen.bussinessGoods.wrapper.BussinessGoodsWrapper;
import org.springblade.modules.guosen.bussinessGoods.service.IBussinessGoodsService;
import org.springblade.core.boot.ctrl.BladeController;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-09-24
 */
@RestController
@AllArgsConstructor
@RequestMapping("cyzh-bussiness-goods/bussinessgoods")
@Api(value = "", tags = "接口")
public class BussinessGoodsController extends BladeController {

	private final IBussinessGoodsService bussinessGoodsService;
	private final IBussinessService bussinessService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入bussinessGoods")
	public R<BussinessGoodsVO> detail(BussinessGoods bussinessGoods) {
		BussinessGoods detail = bussinessGoodsService.getOne(Condition.getQueryWrapper(bussinessGoods));
		return R.data(BussinessGoodsWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入bussinessGoods")
	public R<IPage<BussinessGoodsVO>> list(BussinessGoods bussinessGoods, Query query) {
		BladeUser user = AuthUtil.getUser();
		Bussiness bussiness = bussinessService.getBaseMapper().selectOne(new QueryWrapper<>(new Bussiness()).lambda()
				.eq(Bussiness::getAccountId, user.getUserId()));
		if(user.getRoleName().equals("商户")){
			bussinessGoods.setBussinessId(bussiness.getId());
		}
		LambdaQueryWrapper<BussinessGoods> lambdaQueryWrapper = new LambdaQueryWrapper<>();
		lambdaQueryWrapper.like(StringUtil.isNotBlank(bussinessGoods.getGoodsName()), BussinessGoods::getGoodsName, bussinessGoods.getGoodsName());
		lambdaQueryWrapper.eq(bussinessGoods.getBussinessId() != null, BussinessGoods::getBussinessId, bussinessGoods.getBussinessId());
		lambdaQueryWrapper.eq(bussinessGoods.getGoodsNo() != null, BussinessGoods::getGoodsNo, bussinessGoods.getGoodsNo());
		IPage<BussinessGoods> pages = bussinessGoodsService.page(Condition.getPage(query), lambdaQueryWrapper);
		return R.data(BussinessGoodsWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页 
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入bussinessGoods")
	public R<IPage<BussinessGoodsVO>> page(BussinessGoodsVO bussinessGoods, Query query) {
		IPage<BussinessGoodsVO> pages = bussinessGoodsService.selectBussinessGoodsPage(Condition.getPage(query), bussinessGoods);
		return R.data(pages);
	}

	/**
	 * 新增 
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入bussinessGoods")
	public R save(@Valid @RequestBody BussinessGoods bussinessGoods) {
		return R.status(bussinessGoodsService.save(bussinessGoods));
	}

	/**
	 * 修改 
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入bussinessGoods")
	public R update(@Valid @RequestBody BussinessGoods bussinessGoods) {
		return R.status(bussinessGoodsService.updateById(bussinessGoods));
	}

	/**
	 * 新增或修改 
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入bussinessGoods")
	public R submit(@Valid @RequestBody BussinessGoods bussinessGoods) {
		Long bussinessId = bussinessGoods.getBussinessId();
		if(bussinessId != null){
			Bussiness bussiness = bussinessService.getById(bussinessId);
			bussinessGoods.setBussinessName(bussiness.getName());
		}
		return R.status(bussinessGoodsService.saveOrUpdate(bussinessGoods));
	}

	
	/**
	 * 删除 
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(bussinessGoodsService.deleteLogic(Func.toLongList(ids)));
	}

	
}
